
bmap tex01 = <bumpgrass.tga>;
bmap tex02 = <grasdunkel.bmp>; 
bmap tex03 = <grashell.bmp>;
bmap tex04 = <erde.bmp>; 

function multirgb_roughness2() 
{	
	bmap_to_mipmap(mtl.Skin1);
	bmap_to_mipmap(mtl.Skin2);
	bmap_to_mipmap(mtl.Skin3);
	bmap_to_mipmap(mtl.Skin4);
}

material multi_terr
{
	flags = tangent;
	skin1 = tex01;
	skin2 = tex02;
	skin3 = tex03;
	skin4 = tex04;
	event = multirgb_roughness2;
	effect= "
float4x4 matWorldViewProj;	
	
float4x4 matWorld;
float4x4 matWorldView;	
float4 vecAmbient;	
float4 vecSunDir;
float4 vecViewPos;
float4 vecViewDir;	
float4 vecFog;
		
		
//texture mtlSkin1;					
texture mtlSkin2;					
texture mtlSkin3;					
texture mtlSkin4;
					
texture entSkin1;					
texture entSkin2;					
		


sampler a_lpha = sampler_state			
{
Texture = <entSkin1>;  
MipFilter = Linear;
MinFilter = Linear;
MagFilter = Linear;
AddressU = wrap;	
AddressV = Wrap;
};
sampler RGBmap = sampler_state			
{
Texture = <entSkin2>;  
MipFilter = Linear;
MinFilter = Linear;
MagFilter = Linear;
AddressU = Wrap;	
AddressV = Wrap;
};


sampler green = sampler_state			
{
Texture = <mtlSkin2>;  
MipFilter = Linear;
MinFilter = Linear;
MagFilter = Linear;
AddressU = Wrap;	
AddressV = Wrap;
};

sampler blue = sampler_state			
{
Texture = <mtlSkin3>;	
MipFilter = Linear;
MinFilter = Linear;
MagFilter = Linear;
AddressU = Wrap;	
AddressV = Wrap;
};



sampler red = sampler_state			
{
Texture = <mtlSkin4>;	
MipFilter = Linear;
MinFilter = Linear;
MagFilter = Linear;
AddressU = Wrap;	
AddressV = Wrap;
};

		

float DoFog(float4 Pos)	{
float3 P = mul(Pos,matWorldView);// apply the linear fog formula   		
return saturate((vecFog.y-P.z) * vecFog.z);	
}

void VS(
                in float4 vPos         : POSITION,
                in float3 normal       : NORMAL,
                in float2 InTex        : TEXCOORD0,
  

                out float4 Pos 	       : POSITION,
                out float  Fog	       : FOG,
                out float2 Tex         : TEXCOORD0,
                out float2 Tex2         : TEXCOORD1,

                out float4 OutSunDir   : COLOR0)
{
			   
        Pos = mul(vPos,matWorldViewProj);

        OutSunDir = saturate(dot(-vecSunDir,normalize(normal)));
  
        Fog = DoFog(vPos);
        Tex.xy = InTex.xy*10;
        Tex2.xy = InTex.xy;

}
			
		
float4 PS( 
                 in float4 Pos 	       : POSITION,
                 in float  Fog	       : FOG,

                 in float4 InSunDir    : COLOR0,
                 in float2 Tex2         : TEXCOORD1,
                 in float2 Tex         : TEXCOORD0) : COLOR
{

// Def.
//////////////////////////////////////////////////////////////////////////////////////
	float4 Sun        = InSunDir;
	
//////////////////////////////////////////////////////////////////////////////////////
float4 RGB  = tex2D(RGBmap,Tex2);


// Base
//////////////////////////////////////////////////////////////////////////////////////        
        float4 BaseColor  = tex2D(a_lpha,Tex);
     
// RED
//////////////////////////////////////////////////////////////////////////////////////               
        float4 RedColor   = tex2D(red,Tex);

// GREEN
///////////////////////////////////////////////////////////////////////////////////////
	float4 GreenColor  = tex2D(green,Tex);

	
// BLUE
///////////////////////////////////////////////////////////////////////////////////////
	float4 BlueColor  = tex2D(blue,Tex);


	
float4 BaseRed = lerp(GreenColor,RedColor,RGB.r);
float4 BaseGreen = lerp(BaseRed,BaseColor,RGB.g);
float4 FinalColor = lerp(BaseGreen,BlueColor,RGB.b);

FinalColor.a = 1.0f; // prevent transparency

float4 c = FinalColor;

			        
        float4 FinalbumpColor = c*Sun;
        return FinalbumpColor;
}
	
		
technique mytechnique
{
			
pass p0
	{				
	VertexShader = compile vs_1_0 VS();
	PixelShader = compile ps_1_4  PS();
	}
}";
}

action terr_para
{
	my.material=multi_terr;
}


//---------------------------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------------------------



